
#include <stdlib.h>
#include <math.h>

#ifndef	M_PI
#define M_PI	3.14159265358979323846
#endif

#define ENV	"HFC_RATIO"

double	HFC_ratio=1.0;

static int	s=1;

static void	Env()
{
	char	*e;

	if (s) {
	    s=0; if ((e=getenv(ENV))!=NULL) HFC_ratio=atof(e);
	}
}

#define I(t)	(cos(t)+t*sin(t)-1.0)

double	HFC_RF(int k)
{
	double	a,b;

	Env();

	if (k==0) return HFC_ratio*HFC_ratio/4.0;

	a=(b=M_PI*(double)k)*HFC_ratio; return I(a)/(2.0*b*b);
}

double	HFC_SF(int k)
{
	double	a,b,c,d;

	Env();

	a=(double)k; b=1.0-2.0*a;
		     c=1.0+2.0*a; d=HFC_ratio*M_PI/2.0;
	return (2.0/(b*c)-cos(d*b)/b-cos(d*c)/c)/(M_PI*M_PI);
}

double	HFC_CF(int k)
{
	double	a,b,c,m,d,p;

	Env();

	if (k==0) {
	    a=M_PI*HFC_ratio;
	    return HFC_ratio*HFC_ratio/8.0+I(a)/(4.0*M_PI*M_PI);
	}
	if (k==(-1) || k==1) {
	    a=2.0*(b=M_PI*HFC_ratio);
	    return HFC_ratio*HFC_ratio/16.0+(I(a)/8.0+I(b))/(4.0*M_PI*M_PI);
	}
	a=(double)k; b=M_PI*a*HFC_ratio; c=M_PI*(m=1.0-a)*HFC_ratio;
					 d=M_PI*(p=1.0+a)*HFC_ratio;
	return (I(b)/(a*a)+(I(c)/(m*m)+I(d)/(p*p))/2.0)/(4.0*M_PI*M_PI);
}
