
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#ifndef	M_PI
#define M_PI	3.14159265358979323846
#endif

static void	Error(char *msg)
{
	(void)fputs(msg,stderr); (void)fputc('\n',stderr); exit(1);
}

#define LEN	2048

int	main(int argc,char **argv)
{
	FILE    *file;
	char    str[LEN];
	int	N,M,m,n,O=0;
	double	dr,p0,p1,p2,p,r2,s,s0=0.0,s1=0.0;

	if (argc!=3) Error("usage : sg_ca SG.bin dr");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fgets(str,LEN,file)==NULL ||
	    sscanf(str,"%d %d",&N,&M)!=2 ||
	    N<=0 || M<=0) Error("bad data size.");

	if ((dr=atof(argv[2]))<=0.0) Error("bad detector interval.");

	for (m=0; m<M; m++) {
	    p0=p1=p2=0.0;
	    for (n=0; n<N; n++) {
		if (fread(&p,sizeof(p),1,file)!=1) Error("data read error.");

		p0+=p; p1+=(p*(double)n); p2+=(p*(double)n*(double)n);
	    }
	    (void)printf("%d\t%le\t",m,p0*dr);
	    if (p0<=0.0 || (r2=4.0*(p2/p0-p1*p1/(p0*p0)))<=0.0)
		(void)puts("0\t0");
	    else {
		(void)printf("%lg\t%lg\n",sqrt(r2),p0/(M_PI*r2)/dr);

		++O; s0+=(p0*p0); s1+=(p0*p2-p1*p1);
	    }
	}
	if (file!=stdin) (void)fclose(file);

	(void)fprintf(stderr,"%d\t",O);
	if (O==0)
	    (void)fputs("0\t0\t0\n",stderr);
	else {
	    (void)fprintf(stderr,"%le\t",(s=sqrt(s0/(double)O))*dr);
	    if (s0<=0.0 || (r2=4.0*s1/s0)<=0.0)
		(void)fputs("0\t0\n",stderr);
	    else
		(void)fprintf(stderr,"%lg\t%lg\n",sqrt(r2),s/(M_PI*r2)/dr);
	}
	return 0;
}
