
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "fft.h"

extern void	Error(char *msg);

#define LEN	2048

int	main(int argc,char **argv)
{
	FILE	*file;
	char	str[LEN];
	int	N,M,L,L2,j,k;
	Complex	*E,*C,*S;
	double	w,dr=1.0;

	if (argc!=2 && argc!=3) Error("usage : sg_es SG {dr}");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fgets(str,LEN,file)==NULL ||
	    sscanf(str,"%d %d",&N,&M)!=2 ||
	    N<=0 || M<=0) Error("bad data size.");

	if ((L=SetUpFFT(N,&E))==0 ||
	    (C=(Complex *)malloc(sizeof(*C)*L))==NULL ||
	    (S=(Complex *)malloc(sizeof(*S)*((L2=L/2)+1)))==NULL)
	    Error("memory allocation error.");

	for (j=0; j<=L2; j++) S[j].r=S[j].i=0.0;

	if (argc==3) dr=atof(argv[2]);

	for (k=0; k<M; k++) {
	    for (j=0; j<N; j++) {
		if (fread(&w,sizeof(w),1,file)!=1) Error("data read error.");

		C[j].r=w*dr; C[j].i=0.0;
	    }
	    for (; j<L; j++) C[j].r=C[j].i=0.0;

	    FFT(-1,L,E,C);

	    for (j=0; j<=L2; j++) {
		w=C[j].r*C[j].r+C[j].i*C[j].i; S[j].r+=w; S[j].i+=(w*w);
	    }
	}
	if (file!=stdin) (void)fclose(file);

	for (j=0; j<=L2; j++) {
	    w=S[j].r/(double)M;
	    (void)printf("%d\t%le\t%le\n",j,w,sqrt(S[j].i/(double)M-w*w));
	}
	free(S); free(C); free(E); return 0;
}
