
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "fft.h"

#ifndef	M_PI
#define M_PI	3.14159265358979323846
#endif

extern void	Error(char *msg);

#define LEN	2048

int	main(int argc,char **argv)
{
	FILE	*org,*new;
	char	str[LEN];
	int	N,M,L,j,k;
	Complex	*E,*C;
	double	*G,R,d,p;

	if (argc!=4) Error("usage : sg_gf orgSG radius newSG");

	if (argv[1][0]=='-')
	    org=stdin;
	else
	    if ((org=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fgets(str,LEN,org)==NULL ||
	    sscanf(str,"%d %d",&N,&M)!=2 ||
	    N<=0 || M<=0) Error("bad data size.");

	if ((L=SetUpFFT(N,&E))==0 ||
	    (C=(Complex *)malloc(sizeof(*C)*L))==NULL ||
	    (G=(double *)malloc(sizeof(*G)*L))==NULL)
	    Error("memory allocation error.");

	R=atof(argv[2]);

	if (argv[3][0]=='-')
	    new=stdout;
	else
	    if ((new=fopen(argv[3],"wb"))==NULL) Error("file not open.");

	(void)fprintf(new,"%d\t%d\n",N,M);

	for (j=0; j<L; j++) {
	    d=M_PI*R*(double)((j+L/2)%L-L/2)/(double)L; G[j]=exp(-d*d);
	}
	for (k=0; k<M; k++) {
	    for (j=0; j<N; j++) {
		if (fread(&p,sizeof(p),1,org)!=1) Error("data read error.");

		C[j].r=p/(double)L; C[j].i=0.0;
	    }
	    for (; j<L; j++) C[j].r=C[j].i=0.0;

	    FFT(-1,L,E,C);

	    for (j=0; j<L; j++) {
		C[j].r*=G[j]; C[j].i*=G[j];
	    }
	    FFT(1,L,E,C);

	    for (j=0; j<N; j++) (void)fwrite(&(C[j].r),sizeof(C[j].r),1,new);
	}
	if (org!=stdin ) (void)fclose(org);
	if (new!=stdout) (void)fclose(new); free(G); free(C); free(E); return 0;
}
