
#include <stdio.h>
#include <stdlib.h>
#include "fft.h"

extern void	Error(char *msg);

#define LEN	2048

int	main(int argc,char **argv)
{
	FILE	*org,*new;
	char	str[LEN];
	int	N,M,L,L1,L2,k,j;
	Complex	*E,*C;
	double	p;

	if (argc!=4) Error("usage : sg_hfc orgSG ratio newSG");

	if (argv[1][0]=='-')
	    org=stdin;
	else
	    if ((org=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fgets(str,LEN,org)==NULL ||
	    sscanf(str,"%d %d",&N,&M)!=2 ||
	    N<=0 || M<=0) Error("bad data size.");

	if ((L=SetUpFFT(N,&E))==0 ||
	    (C=(Complex *)malloc(sizeof(*C)*L))==NULL)
	    Error("memory allocation error.");

	if ((L1=(int)(atof(argv[2])*(double)(L/2))+1)<1) L1=1; L2=L-L1;

	if (argv[3][0]=='-')
	    new=stdout;
	else
	    if ((new=fopen(argv[3],"wb"))==NULL) Error("file not open.");

	(void)fprintf(new,"%d\t%d\n",N,M);

	for (k=0; k<M; k++) {
	    for (j=0; j<N; j++) {
		if (fread(&p,sizeof(p),1,org)!=1) Error("data read error.");

		C[j].r=p/(double)L; C[j].i=0.0;
	    }
	    for (; j<L; j++) C[j].r=C[j].i=0.0;

	    FFT(-1,L,E,C);

	    for (j=L1; j<=L2; j++) C[j].r=C[j].i=0.0;

	    FFT(1,L,E,C);

	    for (j=0; j<N; j++) (void)fwrite(&(C[j].r),sizeof(C[j].r),1,new);
	}
	if (org!=stdin ) (void)fclose(org);
	if (new!=stdout) (void)fclose(new); free(C); free(E); return 0;
}
