
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#ifndef	M_PI
#define M_PI	3.14159265358979323846
#endif

static void	Error(char *msg)
{
	(void)fputs(msg,stderr); (void)fputc('\n',stderr); exit(1);
}

#define LEN	2048

int	main(int argc,char **argv)
{
	FILE    *file;
	char    str[LEN];
	int	N,M,m,n;
	double	P,pn,p,r,t,s,d,C=0.0,R=0.0,rs=0.0,rc=0.0;

	if (argc!=2 && argc!=3) Error("usage : sg_rc SG.bin {rotationCenter}");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fgets(str,LEN,file)==NULL ||
	    sscanf(str,"%d %d",&N,&M)!=2 ||
	    N<=0 || M<=0) Error("bad data size.");

	if (argc==3) C=atof(argv[2]);

	for (m=0; m<M; m++) {
	    P=pn=0.0;
	    for (n=0; n<N; n++) {
		if (fread(&p,sizeof(p),1,file)!=1) Error("data read error.");

		P+=p; pn+=(p*(double)n);
	    }
	    R+=(r=pn/P-C); t=M_PI*(double)m/(double)M; rs+=(r*sin(t));
						       rc+=(r*cos(t));
	}
	if (file!=stdin) (void)fclose(file);

	s=1.0/tan(M_PI/2.0/(double)M);	/* =Sum[Sin[Pi*m/M],{m,0,M-1}] */

#define c	1.0		/* =Sum[Cos[Pi*m/M],{m,0,M-1}] */
#define s2	((double)M/2.0)	/* =Sum[Sin[Pi*m/M]^2,{m,0,M-1}] */
#define c2	((double)M/2.0)	/* =Sum[Cos[Pi*m/M]^2,{m,0,M-1}] */
#define cs	0.0		/* =Sum[Sin[Pi*m/M]*Cos[Pi*m/M],{m,0,M-1}] */

	if (argc==2)
{
#define D(x1,y1,z1,x2,y2,z2,x3,y3,z3)	(x1*y2*z3+x2*y3*z1+x3*y1*z2 \
					-x3*y2*z1-x2*y1*z3-x1*y3*z2)

	d=D(c2,cs,c,
	    cs,s2,s,
	    c ,s ,(double)M);
	(void)printf("%lg\t%lg\t%lg\n",D(rc,cs,c,
					 rs,s2,s,
					 R ,s ,(double)M)/d,
				       D(c2,rc,c,
					 cs,rs,s,
					 c ,R ,(double)M)/d,
				       D(c2,cs,rc,
					 cs,s2,rs,
					 c ,s ,R        )/d);
}
	else
{
	d=c2*s2-cs*cs;
	(void)printf("%lg\t%lg\n",(s2*rc-cs*rs)/d,(c2*rs-cs*rc)/d);

	/* r[m]=Sum[p[n,m]*n,{n,0,N-1}]/Sum[p[n,m],{n,0,N-1}]-C */
	/* x=Sum[r[m]*Cos[Pi*m/M],{m,0,M-1}]/(M/2) */
	/* y=Sum[r[m]*Sin[Pi*m/M],{m,0,M-1}]/(M/2) */
}
	return 0;
}
